<mat-tab-group animationDuration="0ms">
  <!-- USERS -->
  <mat-tab label="Users" class="users-tab">
    <div class="top-container-users">
      <div></div>
      <div class="searchbar">
        <mat-form-field class="search" appearance="fill">
          <mat-label>Search users</mat-label>
          <input
            matInput
            type="text"
            [(ngModel)]="search"
            (keyup.enter)="getUsers($event)"
          />
          <button
            *ngIf="search"
            matSuffix
            mat-icon-button
            aria-label="Clear"
            (click)="search = ''; getUsers($event)"
          >
            <mat-icon>close</mat-icon>
          </button>
          <button *ngIf="!search" matSuffix mat-icon-button>
            <mat-icon>search</mat-icon>
          </button>
        </mat-form-field>
      </div>

      <div class="new">
        <span class="actions">
          <button mat-raised-button color="primary" (click)="inviteUser()">
            <i class="material-icons">add</i> Invite
          </button>
        </span>
      </div>
    </div>

    <ul *ngIf="users && all_roles" class="users">
      <li *ngIf="users.total == 0">No users found.</li>
      <li class="users-header">
        <span class="name"> Name </span>
        <span class="email"> Email </span>
        <span class="roles"> Roles </span>
        <span class="status"> Status </span>
        <span class="access_key_id"> Access Key ID </span>
        <span class="creds"> </span>
        <span class="actions"> </span>
      </li>
      <li *ngFor="let user of users.data" class="user">
        <user-component [user]="user" [roles]="all_roles.data">
        </user-component>

        <span class="creds">
          <button
            mat-raised-button
            color="primary"
            *ngIf="user.access_key_id; else notShow"
            (click)="generateCredentials(user)"
          >
            Regenerate <i class="material-icons">key</i>
          </button>
        </span>
        <ng-template #notShow>
          <span class="creds">
            <button
              mat-raised-button
              color="primary"
              *ngIf="user.confirmed_at; else confirmation"
              (click)="generateCredentials(user)"
            >
              Generate <i class="material-icons">key</i>
            </button>
          </span>
        </ng-template>
        <ng-template #confirmation>
          <span class="validation-link">
            <button
              mat-raised-button
              color="primary"
              (click)="validationLink(user)"
            >
              <i class="material-icons">key</i> Get valid. link
            </button>
          </span>
        </ng-template>

        <span class="actions">
          <button
            mat-raised-button
            color="primary"
            [disabled]="!right_administrator || user.id == 1"
            (click)="editUser(user)"
          >
            <i class="material-icons">mode_edit</i>
          </button>
        </span>

        <span class="actions">
          <button
            mat-raised-button
            color="primary"
            [disabled]="current_user_id != 1"
            (click)="changeUserPassword(user)"
          >
            <i class="material-icons">lock_reset</i>
          </button>
        </span>

        <span class="actions">
          <button
            mat-raised-button
            color="warn"
            [disabled]="!right_administrator || user.id == 1"
            (click)="removeUser(user)"
          >
            <i class="material-icons">delete</i>
          </button>
        </span>
      </li>
    </ul>

    <mat-paginator
      class="paginator"
      showFirstLastButtons="true"
      [length]="length"
      [pageSize]="pageSize"
      [pageSizeOptions]="pageSizeOptions"
      [pageIndex]="page"
      (page)="eventGetUsers($event)"
    >
    </mat-paginator>
  </mat-tab>

  <!-- ROLES -->
  <mat-tab label="Roles">
    <div class="top-container-roles">
      <div class="title">
        <i class="material-icons">add</i>
        <label> Add Role </label>
      </div>
      <div class="form">
        <mat-form-field class="role-name-input">
          <input
            matInput
            type="text"
            placeholder="Name"
            [(ngModel)]="new_role_name"
          />
        </mat-form-field>
        <button
          mat-button
          color="primary"
          (click)="createRole()"
          [disabled]="!new_role_name"
        >
          <i class="material-icons">add</i>
          Add role
        </button>
        <span class="message">
          {{ role_error_message }}
        </span>
      </div>
    </div>

    <div *ngIf="roles && available_permissions" class="roles">
      <p *ngIf="roles.total == 0">No roles found.</p>
      <role-component
        *ngFor="let role of roles.data"
        [role]="role"
        (roleChange)="roleHasChanged($event)"
        (selectRole)="roleHasBeenSelected(Role)"
        [permissions]="available_permissions"
        [selected_role]="selected_role_id"
      >
      </role-component>
    </div>

    <mat-paginator
      class="paginator"
      showFirstLastButtons="true"
      [length]="roles_total"
      [pageSize]="pageSize"
      [pageSizeOptions]="pageSizeOptions"
      [pageIndex]="page"
      (page)="eventGetRoles($event)"
    >
    </mat-paginator>
  </mat-tab>
</mat-tab-group>
